<?php
require_once "events.php";

function webDashboard($socket, $n="Général")
{
	global $dashboards, $indexDevices;
	require_once "webserver/javascript.php";
	logger(DEBUG, _("webDashboard function"));
	$response = insertJavascript();

	if(array_key_exists($n, $dashboards))
	{
		foreach ($dashboards[$n] as $array)
		{
			if (array_key_exists($array[0], $indexDevices))
			{
				$device = $indexDevices[$array[0]];
				$property = $array[1];
				if (array_key_exists($array[1], $device->properties))
				{
					$propertyObject = $device->properties[$property];
					$value = $propertyObject["value"];
					logger(DEBUG, $device->friendlyName . " => " . bool2string(_($value)));
					$response .= $device->friendlyName . aliases($device->friendlyName, $property) . " => " . bool2string(_($value)) . EOL;
					if (array_key_exists("access", $propertyObject))
					{
						logger(DEBUG, _("Access = ") . $propertyObject["access"], __FILE__ . ":" . __LINE__);
						if(($propertyObject["access"] & 2))
						{
							logger(DEBUG, _("Write Access OK ") . ($propertyObject["access"] & 2), __FILE__ . ":" . __LINE__);
							$response .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" . displayChoice($device, $property);
						}
						if(($propertyObject["access"] & 4))
						{
							logger(DEBUG, _("can get value") . ($propertyObject["access"] & 4), __FILE__ . ":" . __LINE__);
							$response .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" id="' . $device->topic ."/" .  $device->friendlyName . "/" . $propertyObject["name"] . '" value="'  . _("Update") . "\" onmouseup=\"getPropertyValue('" . $device->topic . "','" . $device->friendlyName . "','" . $propertyObject["name"] . "')\">";
						}
					}
						$response .= EOLH;
				}else
				{
					logger(ERROR, _("Property do not exist"), __FILE__ . ":" . __LINE__);
				}
			}else
			{
				logger(ERROR, _("Device do not exist"), __FILE__ . ":" . __LINE__);
			}
		}
	}else
	{
		$response = _("dashboard not found");
	}
	htmlSend($socket, $response);
}

function displayChoice($device, $propertyName)
{
	logger(INFO, _("function displayChoice"), __FILE__ . ":" . __LINE__);
	$propertyObject = $device->properties[$propertyName];

	if(array_key_exists("unit", $propertyObject))
	{
		$unit = $propertyObject["unit"];
		logger(DEBUG, _("unit = ") . $unit, __FILE__ . ":" . __LINE__);
	}
	if (!array_key_exists("type", $propertyObject))		return "";
	switch ($propertyObject["type"])
	{
		case "binary":
			logger(DEBUG, _("type is binary"), __FILE__ . ":" . __LINE__);
			$choice["on"] = $propertyObject["value_on"];
			$choice["off"] = $propertyObject["value_off"];
			if (array_key_exists("toggle", $propertyObject))
			{
				$choice["toggle"] = $propertyObject["toggle"];
			}
			$formHTML = mkHTML($device, $propertyName, $choice);
			break;
		case "numeric":
			logger(DEBUG, _("type is numeric"), __FILE__ . ":" . __LINE__);
			$formHTML = '<input type="range" id="' . $propertyObject["name"] . '"';
			$formHTML .= ' name="' . $propertyObject["name"] . '"';
			$formHTML .= ' min="' . $propertyObject["value_min"] . '"';
			$formHTML .= ' max="' . $propertyObject["value_max"] . '"';
			$formHTML .= ' value="' . $propertyObject["value"] . '"';

			if (array_key_exists("value_step", $propertyObject))
			{
				$formHTML .= ' step="' . $propertyObject["value_step"] . '"';
			}
			$formHTML .= " onchange=\"setPropertyValue('" . $device->topic . "', '" .  $device->friendlyName . "', this.value, '" . $propertyObject["name"] . "')\">";

			break;
		case "enum":
			logger(DEBUG, _("type is enum"), __FILE__ . ":" . __LINE__);
			$choice = $propertyObject["values"];
			$formHTML = mkHTML($device, $propertyName, $choice);
			break;
	}
	return $formHTML;
}

function mkHTML($device, $propertyName, $choice)
{
	global $listenPort, $httpServerIp;
	$html = "";
	logger(DEBUG, _("function mkHTML"), __FILE__ . ":" . __LINE__);
	foreach ($choice as $key => $value)
	{
		$html .= '<input type="button" id="' . $device->topic ."/" .  $device->friendlyName . "/" . $propertyName . "/" . $key . '" value="'  . $value . "\" onmouseup=\"setPropertyValue('" . $device->topic . "', '" . $device->friendlyName . "', '" . $value . "', '" . $propertyName . "')\">";
	}
	return $html;
}

function webBrowse($socket, $argList, $page="/browse")
{
	global $topics, $devices, $listenPort,$indexDevices;
	logger(DEBUG, _("Generic response to choose device and property"), __FILE__ . ":" . __LINE__);
	//$response = "<html><header></header><body>" . _("unknown command") .  "</body></html>";
	$response = "";
	$flag = false;
	$tab = "";

	if (array_key_exists("topic", $argList))
	{
		if (array_key_exists($argList["topic"], $topics))
		{
			logger(DEBUG, _("Topic exists: ") . $argList["topic"] , __FILE__ . ":" . __LINE__);
			$topicRef = '<a href="/browse&amp;topic=' . htmlentities($argList["topic"]);
			if (array_key_exists("fn", $argList))
			{
				logger(DEBUG, _("FriendlyName exists: ") . $argList["fn"] , __FILE__ . ":" . __LINE__);
				$fn = "";
				$fnArray = explode("/", $argList["fn"]);
				$device = $devices[$argList["topic"]];

				//var_dump($fnArray);
				foreach($fnArray as $value)
				{
					if ($flag) $fn .= "/";
					$fn .= $value;
					if (!array_key_exists($value, $device))
					{
						htmlSend($socket, sprintf(_('"%s" does not exists'),  $value));
						return false;
					}
					$device = $device[$value];
					$flag = true;
				}
				//var_dump($device);
				if (array_key_exists("device", $device))  // TODO
				{
					$device = $device["device"];
					$fn .= "device/" . $fn;
				}

				if (is_a($device, "device"))
				{
					require_once "webserver/javascript.php";
					$response .= insertJavascript();
					foreach($device->properties as $key => $value)
					{
						$response = displayProperty($device, $key, $value, $response);
					}
					/*foreach($device->properties as $key => $value)
					{
						$response = value($key, $value, $response);
					}*/
				}else
				{
					foreach($device as $key => $value)
					{
						$response .= $topicRef . htmlentities("&fn=" . $fn . "/" . $key) . '">' . $key . "</a><br>\n";
					}
				}
				//logger(DEBUG, _("response: ") . EOL . $response , __FILE__ . ":" . __LINE__);
				//htmlSend($socket, $response);
			}else
			{
				logger(DEBUG, _("no FriendlyName given"), __FILE__ . ":" . __LINE__);
				if (empty($devices[$argList["topic"]]))
				{
					$response .= _("No devices yet found");
				}else
				{
					foreach($devices[$argList["topic"]] as $key => $value)
					{
						//print "key = " . print_r($key, true) . " value = " . print_r($value, true) . EOL;
						logger(DEBUG, _("devices de topic: ") . $key , __FILE__ . ":" . __LINE__);
						$response .= $topicRef . htmlentities("&fn=" . $key) . '">' . $key . "</a><br>\n";
						logger(DEBUG, _("response: ") . $response , __FILE__ . ":" . __LINE__);
					}
				}
			}
		}else
		{
			$response = webListTopics();
		}
	}else
	{
		$response = webListTopics();
	}
	htmlSend($socket, $response);
}

function displayProperty($device, $key, $value, $response)
{
	$response .= $key . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	if (array_key_exists("access", $value))
	{
		if(($value["access"] & 2))
		{
			logger(DEBUG, _("Write Access OK ") . ($value["access"] & 2), __FILE__ . ":" . __LINE__);
			$response .= displayChoice($device, $key);
		}
		if(($value["access"] & 4))
		{
			logger(DEBUG, _("can get value") . ($value["access"] & 4), __FILE__ . ":" . __LINE__);
			$response .= '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" id="' . $device->topic ."/" .  $device->friendlyName . "/" . $key . '" value="'  . _("Update") . "\" onmouseup=\"getPropertyValue('" . $device->topic . "', '" . $device->friendlyName . "', '" . $key . "')\">";
		}
	}
	$response .= "<br>\n" . $tab . "[<br>\n";
	//echo memory_get_usage();
	//$response = value($key, $value, $response);
	iterateProperty($device, $key, $value, $response, $tab);
	$response .= $tab . "]<br>\n";
	return $response;
}

function iterateProperty($device, $property, $value, &$response, $tab="")
{
	$tab .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
	if (is_array($value) or is_object($value))
	{
		logger(DEBUG, _("is array"), __FILE__ . ":" . __LINE__ );
		foreach($value as $key => $value2)
		{
			logger(DEBUG, $key, __FILE__ . ":" . __LINE__ );
			$response .= $tab . $key;
			if (is_array($value2) or is_object($value2))
			{
				$response .= "<br>\n";
			}else
			{
				$response .= " = ";
			}
			iterateProperty($device, $key, $value2, $response, $tab);
		}
	}else
	{
		$response .= bool2string($value) . "<br>\n";//. displayChoice($device, $property);	//value($property, $value, "");
	}
}

function webListTopics()
{
	global $topics;
	logger(DEBUG, _("webListTopics function"));
	$response = "";
	foreach ($topics as $name => $topic)
	{
		$response .= '<a href="/browse&topic=' . $name . '">' . $name ."</a><br>\n";
	}
	return $response;
}

function webGet($argList)
{
	if(!array_key_exists("topic", $argList) or !array_key_exists("fn", $argList) or !array_key_exists("property", $argList))
	{
		$response = "GET: " . _("no parameters passed, need topic, fn and property");
	}else
	{
		if (($device = getDevice($argList["topic"], $argList["fn"])) === false)
		{
			$response = sprintf(_('"%s" or "%s" does not exists'), $argList["topic"], $argList["fn"]);
		}else
		{
			$property = $argList["property"];
			$response = "GET: " . bool2string($device->$property["value"]);
		}
	}
	return $response;
}

function webSet($argList)
{
	global $indexFriendlyName;
	if(!array_key_exists("topic", $argList) or !array_key_exists("fn", $argList) or !array_key_exists("property", $argList) or !array_key_exists("value", $argList))
	{
		if (!array_key_exists($argList["topic"], $topics) )
		{
			$response = "SET: " . _("bad parameter passed: topic does not exists") . "<br>\n";
		}
		if (!array_key_exists(!array_key_exists($argList["fn"], $indexFriendlyName)))
		{
			$response = "SET: " . _("bad parameter passed: fn does not exists") . "<br>\n";
		}
		$response .= "SET: " . _("not all parameters passed, need topic, fn, property and value");
	}else
	{
		$response = "setting property " . $argList["property"] . " of " . $argList["fn"] . " to value: " . $argList["value"];
		$payload = array($argList["property"] => $argList["value"]);
		publish(Z2M . "/" . $argList["fn"], $payload);
		//removeEvent($indexFriendlyName($argList["fn"]), $argList["property"], "OFF");
	}
	return $response;
}

function webPrint($argList, $command)
{
	global $GLOBALS, $topics;
	if (array_key_exists($argList["object"], $GLOBALS))
	{
		$var = $GLOBALS[$argList["object"]];

		if (isset($argList["topic"]))
		{
			$topic = $argList["topic"];
		}
		if (isset($argList["address"]))
		{
			$var = $var[$argList["address"]];
		}elseif (isset($argList["fn"]))
		{
			if(!empty($topic))
			{
				$var = getDevice($topic, $argList["fn"]);
			}else
			{
				$str = _("topic is not defining: add &topic=\nThese topics are availables: ");
				foreach($topics as $key => $value)
				{
					$str .= $key . EOL;
				}
				logger(ERROR, $str, __FILE__ . ":" . __LINE__);
			}
		}
		$error = error_get_last();
		if($error !== null)
		{
			$response = $error["message"] . " file: " . $error["file"] . " line: " . $error["line"];
		}
		if ($command === "print")
		{
			$response = "<pre>" . nl2br(print_r($var, true)) . "<pre>";
		}elseif($command === "dump")
		{
			$response = "Dump" . EOL;
			$response .= "<pre>" . nl2br(var_export($var, true)) . "<pre>";
		}
	}else
	{
		$response = _("Object do not exists");
	}
	return $response;
}

function webNotify($argList)
{
	if (!array_key_exists("topic", $argList) or !array_key_exists("fn", $argList) or !array_key_exists("property", $argList) or !array_key_exists("condition", $argList) or !array_key_exists("value", $argList))
	{
		$response = _("Error: With 'notify' command, you need 5 parameters: topic, fn, property, condition, value");
	}else
	{
		$response = _("notify command have been set");
		$monitored[] = new watch($argList["topic"], $argList["fn"], $argList["property"], $argList["condition"], $argList["value"]);
	}
	return $response;
}
/*
function webDisplayByType($argList)
{
	global $indexTypes, $config;
	require_once $config . "porpertiesbytype.php";
	require_once "webserver/javascript.php";

	$response .= insertJavascript();
	foreach($indexTypes[$argList["type"]] as $device)
	{
		foreach($)
		displayProperty($device, $device->, $value, $response)
	}
}
*/
?>
